SystemOrganization addCategory: #ConfigurationOfFamiliar!

Object subclass: #ConfigurationOfFamiliar
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFamiliar'!

!ConfigurationOfFamiliar class methodsFor: 'development support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFamiliar class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFamiliar class methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:10'!
project

	^self new project! !

!ConfigurationOfFamiliar class methodsFor: 'development support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFamiliar methodsFor: 'baselines' stamp: 'AlexandreBergel 7/1/2012 16:10'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Familiar'.
		spec package: 'Familiar'.
		spec group: 'default' with: #('Familiar' ). ].
! !

!ConfigurationOfFamiliar methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 7/2/2012 11:11'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.5'.
! !

!ConfigurationOfFamiliar methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/1/2012 16:10'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!!'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/1/2012 16:10'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.1'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 00:28'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!!
0.2 : Integrated with Moose'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 00:28'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.2'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 01:17'!
version03: spec
	<version: '0.3' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.2 : Integrated with Moose
0.3 : Better support in Moose'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 01:17'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.3'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 11:10'!
version04: spec
	<version: '0.4' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.3 : Better support in Moose
0.4 : Introduced FMFeature. No more plain string'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 11:10'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.4'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 13:05'!
version05: spec
	<version: '0.5' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.4 : Introduced FMFeature. No more plain string
0.5 : Yeah, all the tests are green. The parsing of the production seems to be okay for now.'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 13:05'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.5'. ].
! !
